/*
 * $Id: //depot/prod/spl/main/snapcenter-cli/src/main/java/com/netapp/snapcenter/cli/command/RemoveSmRunAsCommand.java#4 $
 * 
 * Copyright (c) 2015 NetApp, Inc.
 * All rights reserved.
 */

package com.netapp.snapcenter.cli.command;

import com.beust.jcommander.Parameter;
import com.beust.jcommander.Parameters;
import com.netapp.common.logging.MessageBundle;
import com.netapp.smcore.plugin.contracts.SmDeleteRunAsAccountRequest;
import com.netapp.smcore.plugin.contracts.SmDeleteRunAsAccountResponse;
import com.netapp.smcore.plugin.contracts.SmRequest;
import com.netapp.snapcenter.cli.exception.CLIException;
import com.netapp.snapcenter.cli.logging.CLIMsgKey;
import com.netapp.snapcenter.cli.utils.CLIUtils;
import com.netapp.spl.common.restclient.config.SMSRestConfiguration;
import com.netapp.spl.common.restclient.context.SMSRestInvocationContext;

@Parameters(resourceBundle = "snapcenter-cli", commandDescriptionKey = "cli.removesmrunas.command.description")
public class RemoveSmRunAsCommand extends AbstractSMSCommand {

    private static final String COMMAND_NAME = MessageBundle
            .localizeMessage(CLIMsgKey.CLI_REMOVESMRUNAS_COMMAND_NAME);

    @Parameter(names = { "-Name" }, descriptionKey = "cli.removesmrunas.command.name.option.description", required = true)
    private String runAsName;

    @Override
    public String getCommandName() {
        return COMMAND_NAME;
    }

    @Override
    protected void processCommandArguments() throws CLIException {
        CLIUtils.promptUserToContinue(MessageBundle
                .localizeMessage(CLIMsgKey.CLI_REMOVESMRUNAS_PROMPT_USER_REMOVE_RUNAS_ACCOUNT));
    }

    @Override
    protected <T extends SmRequest> SMSRestInvocationContext<?, ?> getCommandSpecificSMSRestInvocationContext(
            T cmdRequest) {
        SMSRestInvocationContext<SmDeleteRunAsAccountRequest, SmDeleteRunAsAccountResponse> smsRestInvocationContext = new SMSRestInvocationContext<>();
        smsRestInvocationContext.setRequest((SmDeleteRunAsAccountRequest) cmdRequest);
        smsRestInvocationContext.setResponseClass(SmDeleteRunAsAccountResponse.class);
        smsRestInvocationContext
                .setServiceUrlPath(SMSRestConfiguration.SMS_RBAC_DELETE_RUN_AS_ACCOUNT_SERVICE_PATH);
        return smsRestInvocationContext;
    }

    public String getRunAsName() {
        return runAsName;
    }

    public void setRunAsName(String runAsName) {
        this.runAsName = runAsName;
    }

}
