/*
 * $Id: //depot/prod/spl/main/snapcenter-cli/src/main/java/com/netapp/snapcenter/cli/command/output/formatter/invokesmresourceclonesplit/InvokeSmResourceCloneSplitCommandOutputFormatterFactory.java#1 $
 *
 * Copyright (c) 2017 NetApp, Inc.
 * All rights reserved.
 */

package com.netapp.snapcenter.cli.command.output.formatter.invokesmresourceclonesplit;

import com.netapp.common.logging.MessageBundle;
import com.netapp.smcore.loader.logger.ExtendedGenericLogger;
import com.netapp.smcore.loader.logger.LoggerFactory;
import com.netapp.snapcenter.cli.command.invokesmcloneresourcesplit.CloneSplitCommandSubType;
import com.netapp.snapcenter.cli.logging.CLIMsgKey;

/**
 * 
 * This is factory class to get output formatter class depending on the option
 * provided for Invoke-SmResourceSplit
 *
 */

public class OutputFormatterFactory {

    private static ExtendedGenericLogger logger = LoggerFactory
            .getExtendedClassAwareLogger(OutputFormatterFactory.class);

    public static OutputFormatter getOutputFormatter(
            CloneSplitCommandSubType cloneSplitCommandSubType) {

        switch (cloneSplitCommandSubType) {
            case ESTIMATE:
                return new OptionEstimateOutputFormatter();
            case START:
            case STOP:
            case STATUS:
                return new OptionCommonOutputFormatter(cloneSplitCommandSubType);
            default:
                logger.error(MessageBundle
                        .localizeMessage(CLIMsgKey.CLI_COMMAND_INVOKESMCLONERESOURCESPLIT_UNKNOWN_OPTION_ERROR));
                return null;

        }
    }
}
