/*
 * $Id: //depot/prod/spl/main/snapcenter-cli/src/main/java/com/netapp/snapcenter/cli/command/parser/CommaParameterSplitter.java#1 $
 * 
 * Copyright (c) 2015 NetApp, Inc.
 * All rights reserved.
 */

package com.netapp.snapcenter.cli.command.parser;

import java.util.ArrayList;
import java.util.List;

import org.apache.commons.lang3.StringUtils;

import com.beust.jcommander.converters.IParameterSplitter;

/**
 * The input parameters values is split based on
 * comma. Here we also take care of trimming the input values.
 * Use this class whenever a parameter is list in command class.
 */

public class CommaParameterSplitter implements IParameterSplitter {

    public List<String> split(String value) {
        List<String> stringList = new ArrayList<>();
        String[] values = value.split(",");
        for (String s : values) {
            stringList.add(StringUtils.trim(s));
        }
        return stringList;
    }
}