/*
 * $Id: //depot/prod/spl/main/snapcenter-cli/src/main/java/com/netapp/snapcenter/cli/command/parser/CustomStringToIntegerListConverter.java#1 $
 * 
 * Copyright (c) 2015 NetApp, Inc.
 * All rights reserved.
 */

package com.netapp.snapcenter.cli.command.parser;

import java.util.ArrayList;
import java.util.List;

import org.apache.commons.lang3.StringUtils;

import com.beust.jcommander.converters.BaseConverter;
import com.beust.jcommander.converters.IntegerConverter;

public class CustomStringToIntegerListConverter extends
        BaseConverter<List<Integer>> {

    private IntegerConverter integerConverter;

    public CustomStringToIntegerListConverter(String optionName) {
        super(optionName);
    }

    @Override
    public List<Integer> convert(String value) {
        integerConverter = new IntegerConverter(getOptionName());
        List<Integer> integerList = new ArrayList<>();

        String listValues = StringUtils.substringBetween(value, "[", "]");
        listValues = (listValues == null) ? value : listValues;

        String[] arrayOfValue = StringUtils.split(listValues, ',');
        for (String val : arrayOfValue) {
            Integer intVal = integerConverter.convert(val.trim());
            integerList.add(intVal);
        }

        return integerList;
    }
}
