/*
 * $Id: //depot/prod/spl/main/snapcenter-cli/src/main/java/com/netapp/snapcenter/cli/command/parser/CustomStringToSchedulesTypeConverter.java#1 $
 * 
 * Copyright (c) 2016 NetApp, Inc.
 * All rights reserved.
 */
package com.netapp.snapcenter.cli.command.parser;

import java.util.ArrayList;
import java.util.List;

import org.apache.commons.lang3.StringUtils;

import com.beust.jcommander.converters.BaseConverter;
import com.netapp.smcore.loader.logger.ExtendedGenericLogger;
import com.netapp.smcore.loader.logger.LoggerFactory;
import com.netapp.snapcenter.cli.contracts.ScheduleType;
import com.netapp.snapcenter.cli.utils.CLIUtils;
import com.netapp.snapcenter.cli.utils.CLIUtils.LogLevel;

/*
 *  CustomStringToSchedulesTypeConverter converts the String to List of Schedule
 */
public class CustomStringToSchedulesTypeConverter extends
        BaseConverter<List<String>> {

    public CustomStringToSchedulesTypeConverter(String optionName) {
        super(optionName);
    }

    ScheduleType scheduleType;
    private ExtendedGenericLogger logger = LoggerFactory
            .getExtendedClassAwareLogger(CustomStringToSchedulesTypeConverter.class);

    @Override
    public List<String> convert(String scheduleType) {
        List<String> scheduleTypeList = new ArrayList<>();

        String listValues = StringUtils
                .substringBetween(scheduleType, "{", "}");
        listValues = (listValues == null) ? scheduleType : listValues;

        String[] arrayOfValue = StringUtils.split(listValues, ',');
        for (String val : arrayOfValue) {
            scheduleTypeList.add(StringUtils.trim(val));
        }

        CLIUtils.writeToLog("Processing  CustomStringToSchedulesTypeConverter "
                + scheduleType + " " + scheduleTypeList, logger, LogLevel.DEBUG);
        return scheduleTypeList;
    }
}
