/*
 * $Id: //depot/prod/spl/main/snapcenter-cli/src/main/java/com/netapp/snapcenter/cli/command/validation/SmsCommandResponseValidationUtil.java#1 $
 * 
 * Copyright (c) 2015 NetApp, Inc.
 * All rights reserved.
 */
package com.netapp.snapcenter.cli.command.validation;

import com.netapp.common.logging.MessageBundle;
import com.netapp.smcore.plugin.contracts.ArrayOfSmBackup;
import com.netapp.smcore.plugin.contracts.ArrayOfSmBackupComponentInfo;
import com.netapp.smcore.plugin.contracts.SmBackup;
import com.netapp.smcore.plugin.contracts.SmGetBackupDetailsResponse;
import com.netapp.snapcenter.cli.exception.CLIException;
import com.netapp.snapcenter.cli.logging.CLIMsgKey;

/**
 * This class has snapcenter specific services response validation.
 */
public class SmsCommandResponseValidationUtil {

    private SmsCommandResponseValidationUtil() {

    }

    public static void checkBackupDetailsResponseInformation(
            SmGetBackupDetailsResponse smGetBackupDetailsResponse)
            throws CLIException {
        ArrayOfSmBackup arrayOfSmBackup = smGetBackupDetailsResponse
                .getBackups();

        if (arrayOfSmBackup == null || arrayOfSmBackup.getSmBackup().isEmpty()) {
            throw new CLIException(
                    MessageBundle
                            .localizeMessage(
                                    CLIMsgKey.CLI_SERVER_UNEXPECTED_ERROR,
                                    MessageBundle
                                            .localizeMessage(CLIMsgKey.CLI_SERVER_BACKUP_DETAILS_RECEIVE_ERROR)));
        }

        SmBackup smBackup = arrayOfSmBackup.getSmBackup().iterator().next();

        ArrayOfSmBackupComponentInfo arrayOfSmBackupComponentInfo = smBackup
                .getBackupComponents();

        if (arrayOfSmBackupComponentInfo == null
                || arrayOfSmBackupComponentInfo.getSmBackupComponentInfo()
                        .isEmpty()) {
            throw new CLIException(
                    MessageBundle
                            .localizeMessage(
                                    CLIMsgKey.CLI_SERVER_UNEXPECTED_ERROR,
                                    MessageBundle
                                            .localizeMessage(CLIMsgKey.CLI_SERVER_BACKUP_DETAILS_RECEIVE_ERROR)));
        }

    }

}
