/*
 * $Id: //depot/prod/spl/main/snapcenter-cli/src/main/java/com/netapp/snapcenter/cli/command/contracts/BackupVerificationType.java#1 $
 * 
 * Copyright (c) 2016 NetApp, Inc.
 * All rights reserved.
 */
package com.netapp.snapcenter.cli.contracts;

public enum BackupVerificationType {
    NONE(1, "NONE"), VERIFY_AFTER_BACKUP(2, "VERIFY_AFTER_BACKUP"), VERIFY_SCHEDULED(
            3, "VERIFY_SCHEDULED");

    private final String value;
    private final int intValue;

    BackupVerificationType(int v, String val) {
        intValue = v;
        value = val;
    }

    public String value() {
        return value;
    }

    public int intValue() {
        return intValue;
    }

    public static BackupVerificationType fromValue(int v) {
        for (BackupVerificationType c : BackupVerificationType.values()) {
            if (c.intValue == v) {
                return c;
            }
        }
        throw new IllegalArgumentException();
    }

    public static BackupVerificationType fromValue(String v) {
        for (BackupVerificationType c : BackupVerificationType.values()) {
            if (c.value().equalsIgnoreCase(v)) {
                return c;
            }
        }
        throw new IllegalArgumentException(v);
    }

}
