/*
 * $Id: //depot/prod/spl/main/snapcenter-cli/src/main/java/com/netapp/snapcenter/cli/command/contracts/DaysOfTheWeek.java#1 $
 * 
 * Copyright (c) 2015 NetApp, Inc.
 * All rights reserved.
 */

package com.netapp.snapcenter.cli.contracts;

import com.netapp.common.logging.MessageBundle;
import com.netapp.snapcenter.cli.logging.CLIMsgKey;

public enum DaysOfTheWeek {

    SUNDAY("Sunday"), MONDAY("Monday"), TUESDAY("Tuesday"), WEDNESDAY(
            "Wednesday"), THURSDAY("Thursday"), FRIDAY("Friday"), SATURDAY(
            "Saturday");

    private final String value;

    DaysOfTheWeek(String v) {
        value = v;
    }

    public String value() {
        return value;
    }

    public static DaysOfTheWeek fromValue(String string) {
        for (DaysOfTheWeek c : DaysOfTheWeek.values()) {
            if (c.value.equalsIgnoreCase(string)) {
                return c;
            }
        }
        throw new IllegalArgumentException(MessageBundle.localizeMessage(
                CLIMsgKey.CLI_SMPOLICY_INVALID_DAY_OF_THE_WEEK, string));

    }
}
