/*
 * $Id: //depot/prod/spl/main/snapcenter-cli/src/main/java/com/netapp/snapcenter/cli/utils/ProgressBarUtil.java#1 $
 * 
 * Copyright (c) 2015 NetApp, Inc.
 * All rights reserved.
 */
package com.netapp.snapcenter.cli.utils;

import com.netapp.smcore.loader.logger.ExtendedGenericLogger;
import com.netapp.smcore.loader.logger.LoggerFactory;
import com.netapp.snapcenter.cli.utils.CLIUtils.LogLevel;

public class ProgressBarUtil {

    private static ExtendedGenericLogger logger = LoggerFactory
            .getExtendedClassAwareLogger(ProgressBarUtil.class);

    private ProgressBarUtil() {

    }

    public static ProgressBar createAndStartProgressBar() {
        return createAndStartProgressBar(null, null);
    }

    public static ProgressBar createAndStartProgressBar(String displayMessage) {
        return createAndStartProgressBar(displayMessage, null);
    }

    public static ProgressBar createAndStartProgressBar(String displayMessage,
            String displayCharacter) {
        ProgressBar progressBar = new ProgressBar();
        progressBar.setDisplayCharacter(displayCharacter);
        progressBar.setDisplayMessage(displayMessage);
        progressBar.start();
        return progressBar;
    }

    public static void stopProgressBar(ProgressBar progressBar) {

        if (progressBar == null) {
            return;
        }

        progressBar.terminate();
        try {
            progressBar.join();
        } catch (InterruptedException e) {
            CLIUtils.writeToLog(e.getLocalizedMessage(), logger, LogLevel.DEBUG);
        }
    }
}
