/*
 * $Id: //depot/prod/spl/main/snapcenter-cli/src/main/java/com/netapp/snapcenter/cli/command/mapper/SMSObjectSerializationUtil.java#1 $
 * 
 * Copyright (c) 2015 NetApp, Inc.
 * All rights reserved.
 */

package com.netapp.snapcenter.cli.utils;

import java.lang.reflect.Method;

import org.apache.commons.lang3.StringUtils;

import com.netapp.smcore.loader.logger.ExtendedGenericLogger;
import com.netapp.smcore.loader.logger.LoggerFactory;
import com.netapp.smcore.plugin.contracts.ObjectFactory;
import com.netapp.snapcenter.cli.formatter.Formatter;
import com.netapp.snapcenter.cli.formatter.FormatterFactory;
import com.netapp.snapcenter.cli.formatter.FormatterType;

/**
 * 
 * This class contains the generic custom mappers for SMS request objects.
 *
 */
public class SMSObjectSerializationUtil {

    private SMSObjectSerializationUtil() {

    }

    private static ExtendedGenericLogger logger = LoggerFactory
            .getExtendedClassAwareLogger(SMSObjectSerializationUtil.class);

    public static String getXMLSerializedSMSObject(Object smsObj) {
        String serializedObject = StringUtils.EMPTY;
        try {
            /**
             * COnstruct JAXBElement<?> using reflection with help of
             * SmCoreContracts ObjectFactory.
             */
            ObjectFactory objFactory = new ObjectFactory();

            String objectFactoryCreateMethod = "create"
                    + smsObj.getClass().getSimpleName();
            Method method = objFactory.getClass().getMethod(
                    objectFactoryCreateMethod, smsObj.getClass());
            Object jaxbElementOfObject = method.invoke(objFactory,
                    new Object[] { smsObj });

            Formatter debugLogXMLFormatter = FormatterFactory
                    .getFormatter(FormatterType.XML);
            serializedObject = debugLogXMLFormatter
                    .getFormattedObject(jaxbElementOfObject);
        } catch (Exception e) {
            logger.debug("Unable to serailize object", e);
        }
        return serializedObject;
    }

}